using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace CheesyFX
{
    public class Elbow : FlexRegion
    {
        public override void Init(int id, string[] rbNames)
        {
            name = "Elbow";
            base.Init(id, rbNames);
            
            rbDynamics = new RBDynamics[2];
            for (int i = 0; i < 2; i++)
            {
                string side = sides[i];
                var rb = FlexIt.singleton.containingAtom.forceReceivers.First(x => x.name == side.ToLower() + rbNames[0])
                    .GetComponent<Rigidbody>();
                rbDynamics[i] = rb.AddRbDynamic(i);
                SetupSupportTrackers(rb);
            }
        }
        
        protected override void SetupDefaults()
        {
            Vector4 dynamicD = dynamicStrengthJ.defaultVal;
            Vector4 minAccelD = minAccelJ.defaultVal;
            Vector4 sRatioD = sRatioJ.defaultVal;
            Vector4 amountD = amountJ.defaultVal;
            
            amountD.x = 1f;
            amountD.y = .65f;
            
            amountJ.val = amountJ.defaultVal = amountD;
            sRatioJ.val = sRatioJ.defaultVal = sRatioD;
            dynamicStrengthJ.val = dynamicStrengthJ.defaultVal = dynamicD;
            minAccel = minAccelJ.val = minAccelJ.defaultVal = minAccelD;
            
            OnAmountChanged(amountJ.val);
            OnSRatioChanged(sRatioJ.val);
        }
    }
}