using System;
using System.Linq;
using Leap.Unity.Animation;
using UnityEngine;

namespace CheesyFX
{
    public class Finger : FlexRegion
    {
        private Func<int, int, float> getFlex;
        public void Init(int id, int fingerId)
        {
            rbDynamics = new RBDynamics[2];
            switch (fingerId)
            {
                case 0:
                {
                    name = "Index";
                    getFlex = (direction, side) =>
                    {
                        if(side == 0) return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, .2f, .1f, .2f, 1f, 0f);
                        return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, -.2f, -.1f, -.2f,
                            0f, 1f);
                    };
                    break;
                }
                case 1:
                {
                    name = "Mid";
                    getFlex = (direction, side) =>
                    {
                        if(side == 0) return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, .1f, 0f, .1f, 1f, 0f);
                        return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, -.1f, 0f, -.1f,
                            0f, 1f);
                    };
                    break;
                }
                case 2:
                {
                    name = "Ring";
                    getFlex = (direction, side) =>
                    {
                        if(side == 0) return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, .1f, 0f, .1f, 1f, 0f);
                        return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, -.1f, 0f, -.1f,
                            0f, 1f);
                    };
                    break;
                }
                case 3:
                {
                    name = "Pinky";
                    getFlex = (direction, side) =>
                    {
                        if (side == 0)
                        {
                            // rbDynamics[side].rigidbody.transform.localRotation.z.Print();
                            return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, -.1f, 0f, -.1f, 0f, 1f);
                        }
                        return FlexIt.MapRange(rbDynamics[side].transform.localRotation.z, .1f, 0f, .1f, 1f, 0f);
                    };
                    break;
                }
            }
            string rbName = name+"1";
            base.Init(id, null);
            for (int i = 0; i < 2; i++)
            {
                string side = sides[i];
                var rb = FlexIt.singleton.containingAtom.rigidbodies.First(x => x.name == side.ToLower() + rbName)
                    .GetComponent<Rigidbody>();
                rbDynamics[i] = rb.AddRbDynamic(i);
            }
        }

        protected override float GetFlex(int direction, int side)
        {
            // if(name == "Pinky" && side ==0) getFlex(direction, side).Print();
            return getFlex(direction, side);
        }
        
        protected override float GetAcceleration(int direction, int side)
        {
            float val = rbDynamics[side].angularAcceleration.z;
            val *= dynamicStrength[direction];
            return val;
        }
    }
}